/*
 *======================================================================
 *
 *Copyright 1992 Sun Microsystems, Inc.
 *
 *The Interface Definition Language Compiler Front End (CFE) is made
 *available for use provided that this legend is included on all media and
 *documentation and as a part of the software program in whole or part.
 *Users may copy and extend functionality (but may not remove
 *functionality) of the Interface Definition Language CFE without charge,
 *but are not authorized to license or distribute it to anyone else except
 *as part of a product or program developed by the user or with the express
 *written consent of Sun Microsystems, Inc.
 *
 *The names of Sun Microsystems, Inc. and any of its subsidiaries may not
 *be used in advertising or publicity pertaining to distribution of
 *Interface Definition Language CFE as permitted herein.
 *
 *The Interface Definition Language CFE may not be exported outside the
 *United States without first obtaining the appropriate government
 *approvals.
 *
 *INTERFACE DEFINITION LANGUAGE CFE IS PROVIDED AS IS WITH NO WARRANTIES
 *OF ANY KIND INCLUDING THE WARRANTIES OF DESIGN, MERCHANTIBILITY AND
 *FITNESS FOR A PARTICULAR PURPOSE, NONINFRINGEMENT, OR ARISING FROM A
 *COURSE OF DEALING, USAGE OR TRADE PRACTICE.
 *
 *Interface Definition Language CFE is provided with no support and
 *without any obligation on the part of Sun Microsystems, Inc. or any of
 *its subsidiaries or affiliates to assist in its use, correction,
 *modification or enhancement.
 *
 *SUN MICROSYSTEMS, INC. OR ANY OF ITS SUBSIDIARIES OR AFFILIATES SHALL
 *HAVE NO LIABILITY WITH RESPECT TO THE INFRINGEMENT OF COPYRIGHTS, TRADE
 *SECRETS OR ANY PATENTS BY INTERFACE DEFINITION LANGUAGE CFE OR ANY PART
 *THEREOF.
 *
 *IN NO EVENT WILL SUN MICROSYSTEMS, INC. OR ANY OF ITS SUBSIDIARIES OR
 *AFFILIATES BE LIABLE FOR ANY LOST REVENUE OR PROFITS OR OTHER SPECIAL,
 *INDIRECT AND CONSEQUENTIAL DAMAGES, EVEN IF SUN HAS BEEN ADVISED OF THE
 *POSSIBILITY OF SUCH DAMAGES.
 *
 *SunSoft, Inc.  
 *2550 Garcia Avenue 
 *Mountain View, California  94043
 *
 *
 *
 *
 *======================================================================
 */

#ifndef _STRING_STRING_HH
#define _STRING_STRING_HH

#pragma ident "%@(#)utl_string.h	1.21% %92/06/10% Sun Microsystems"

// utl_string.hh - contains a quick and dirty TEMPORARY string implementation

/*
** DEPENDENCIES: NONE
**
** USE: Included from util.hh
*/

#ifndef String
#define String	UTL_String
#endif	// String

class	UTL_String
{
public:
  // Operations

  // Constructor(s)
  UTL_String();
  UTL_String(char *str);
  UTL_String(unsigned long maxlen);
  UTL_String(UTL_String *s);

  // AST Dumping
  virtual void		dump(ostream &o);

  // Other Operations

  // Get contents of utl_string
  char			*get_string();

  // Get canonical representation. This is (implemented as) the all upper
  // case corresponding string
  char			*get_canonical_rep();

  // Compare two String *
  virtual long		compare(UTL_String *s);

private:
  // Data
  char		*p_str;		// Storage for characters
  char		*c_str;		// Canonicalized string
  unsigned long	len;		// How long is string
  unsigned long alloced;	// How much allocated

  // Operations
  void		canonicalize();	// Compute canonical representation
};

#endif           // _STRING_STRING_HH
